#!/bin/bash

set -e

DEFAULT_PATH="copy_to_sd"

echo "ISFShax Downloader"
echo "This will download all files requires for ISFShax"
echo ""

if [[ "$1" == "" ]]; then
    read -p "Enter Destination Path (or drag the SD card here) and press Enter [${DEFAULT_PATH}]:" destpath
else
    echo "using path from command line $1"
    destpath="$1"
fi

if [[ "$destpath" == "" ]]; then
    echo "No path entered, using default ${DEFAULT_PATH}"
    destpath="$DEFAULT_PATH"
fi


mkdir -p "${destpath}/wiiu/payloads/fw_img_loader"
cd "$destpath"
mkdir -p "wiiu/ios_plugins"

download_extract() {
    curl -L "$1" -o "$2"
    unzip -o "$2"
    rm "$2"
}

curl -L 'https://github.com/isfshax/isfshax_installer/releases/latest/download/ios.img' -o ios.img
curl -L 'https://github.com/isfshax/isfshax/releases/latest/download/superblock.img' -o superblock.img
curl -L 'https://github.com/isfshax/isfshax/releases/latest/download/superblock.img.sha' -o superblock.img.sha
curl -L 'https://github.com/StroopwafelCFW/stroopwafel/releases/latest/download/00core.ipx' -o wiiu/ios_plugins/00core.ipx
rm -f wiiu/ios_plugins/wafel_core.ipx
curl -L 'https://github.com/isfshax/wafel_isfshax_patch/releases/latest/download/5isfshax.ipx' -o wiiu/ios_plugins/5isfshax.ipx
rm -f wiiu/ios_plugins/wafel_isfshax_patch.ipx
curl -L 'https://github.com/StroopwafelCFW/wafel_payloader/releases/latest/download/5payldr.ipx' -o wiiu/ios_plugins/5payldr.ipx
rm -f wiiu/ios_plugins/wafel_payloader.ipx
curl -L 'https://github.com/StroopwafelCFW/minute_minute/releases/latest/download/fw.img' -o fw.img
curl -L 'https://github.com/StroopwafelCFW/minute_minute/releases/latest/download/boot1.img' -o boot1now.img
curl -L 'https://github.com/jan-hofmeier/unencrypted_fw_img_payload/releases/latest/download/payload.elf' -o wiiu/payloads/fw_img_loader/payload.elf
curl -L 'https://github.com/jan-hofmeier/PayloadLoaderPayload/releases/latest/download/payload.elf' -o wiiu/payload.elf
download_extract 'https://github.com/jan-hofmeier/unencrypted_fw_img_payload/releases/latest/download/fw_img_loader_hbl.zip' fw_img_loader_hbl.zip
download_extract 'https://github.com/wiiu-env/PayloadFromRPX/releases/download/PayloadFromRPX-20230723-084033/PayloadFromRPX_20230723-084033.zip' PayloadFromRPX.zip
mv root.rpx launch.rpx
curl -L 'https://github.com/GaryOderNichts/recovery_menu/releases/latest/download/recovery_menu' -o recovery_menu

mkdir -p hax
curl -L 'https://github.com/StroopwafelCFW/minute_minute/releases/latest/download/fw_fastboot.img' -o hax/fw.img
cp -r wiiu/ios_plugins hax/
rm -f "hax/ios_plugins/0core.ipx" "hax/ios_plugins/6isfshax.ipx" "hax/ios_plugins/9payldr.ipx"
mkdir -p wiiu/apps
curl -L 'https://github.com/isfshax/haxcopy/releases/latest/download/haxcopy.wuhb' -o wiiu/apps/haxcopy.wuhb

echo ""
echo "Download finished successfully"
